<!DOCTYPE composition PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
        "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<ui:composition xmlns:h="http://java.sun.com/jsf/html"
                xmlns:f="http://java.sun.com/jsf/core"
                xmlns:s="http://jboss.org/schema/seam/taglib"
                xmlns:ui="http://java.sun.com/jsf/facelets"
                xmlns:g="http://www.ihe.net/gazelle"
                xmlns:a4j="http://richfaces.org/a4j"
                xmlns:rich="http://richfaces.org/rich"
                xmlns="http://www.w3.org/1999/xhtml"
                template="layout/template.xhtml">
    <ui:define name="body">
        <h:form id="listOfChannelsForm">
            <s:token allowMultiplePosts="true"></s:token>
            <h1>#{messages['net.ihe.gazelle.proxy.ChannelsManagement']}</h1>
            <s:div>
                <a4j:commandButton
                        value="#{messages['net.ihe.gazelle.proxy.Refresh']}"
                        styleClass="gzl-btn-blue pull-right"
                        render="listOfChannelsForm,channelTable,messages"/>
                <a4j:commandButton value="#{messages['net.ihe.gazelle.proxy.DeleteAllChannels']}"
                                   oncomplete="jq162('#stopAllPanel').modal('show');"
                                   styleClass="gzl-btn-red" render=":stopAllPanelForm"
                                   rendered="#{applicationConfigurationManager.isUserAllowedAsAdmin()}"/>
                <a4j:commandButton value="#{messages['net.ihe.gazelle.proxy.DeleteTemporaryChannels']}"
                                   oncomplete="jq162('#stopUnPersistedPanel').modal('show');"
                                   styleClass="gzl-btn-red" render=":stopUnPersistedPanelForm"
                                   rendered="#{applicationConfigurationManager.isUserAllowedAsAdmin()}"/>
                <a4j:commandButton action="/newchannel.xhtml"
                                   value="#{messages['net.ihe.gazelle.proxy.OpenANewChannel']}" render="listOfChannelsForm,messages"
                                   rendered="#{applicationConfigurationManager.isUserAllowedAsAdmin()}"
                                   styleClass="gzl-btn-blue"/>
                <h:commandButton action="#{channelManagerBean.download()}"
                                 value="#{messages['net.ihe.gazelle.proxy.DownloadListOfChannels']}"
                                 rendered="#{applicationConfigurationManager.isUserAllowedAsAdmin()}"
                                 execute="@this" immediate="true" styleClass="gzl-btn-blue"/>
                <h:commandButton action="#{channelManagerBean.syncWithSocketService()}"
                                 value="#{messages['net.ihe.gazelle.proxy.SynchronizeWithSocketService']}"
                                 rendered="#{applicationConfigurationManager.isUserAllowedAsAdmin()}"
                                 execute="@this" immediate="true" styleClass="gzl-btn-blue pull-right"/>
                <br/>
                <br/>
                <h:outputText
                        value="#{messages['net.ihe.gazelle.proxy.ProxyIsAccessibleVia']} : "/>
                <h:outputText
                        value="#{applicationConfigurationManager.proxyIpAddresses}"/>
                <br/>
                <br/>

                <s:div rendered="#{not channelManagerBean.isSocketServiceConnected()}">
                    <p>
                        <span style="color: red; font-weight: bold">
                            #{messages['net.ihe.gazelle.proxy.TheProxyLostConnectionToTheSocketService']}
                        </span>
                        <span style="font-style: italic; font-size: smaller">
                            (#{messages['net.ihe.gazelle.proxy.ThisMessageWillDisappearOnceConnectionIsRestored']})
                        </span>

                        <br/>
                        #{messages['net.ihe.gazelle.proxy.SynchronizationWithTheSocketServiceIsDoneEvery']}
                        <span style="color: blue; font-weight: bold">#{proxyBean.getSyncPeriod()}</span>
                        #{messages['net.ihe.gazelle.proxy.SecondOrManuallyByAnAdministrator']}
                    </p>
                </s:div>

                <rich:dataTable id="channelTable" value="#{channelManagerBean.getListOfChannels()}"
                                var="currentChannel" rows="#{dataScrollerMemory.numberOfResultsPerPage}"
                                render="datascroller">
                    <g:column sortBy="#{'type.identifier'}" filterBy="#{'type.identifier'}">
                        <ui:define name="header">
                            <h:outputText
                                    value="#{messages['net.ihe.gazelle.proxy.ChannelType']}"/>
                        </ui:define>
                        <h:outputText value="#{currentChannel.type}"/>
                        <s:span styleClass="gzl-icon-save" rendered="#{currentChannel.persistent}"
                                title="#{messages['This channel is persistent']}"/>
                        <h:panelGroup rendered="#{currentChannel.securedChannel}">
                            <h:outputLink rendered="#{currentChannel.securedChannel}"
                                          class="gzl-icon-lock"
                                          title="#{messages['net.ihe.gazelle.proxy.TLSSecuredChannelClickToSeeDetails']}"
                                          value="/proxy/admin/securedChannelConfiguration.seam"/>
                            <h:outputText rendered="#{currentChannel.sniEnabled}"
                                          style="font-size: smaller; font-style: italic;"
                                          class="label label-success"
                                          value="#{messages['net.ihe.gazelle.proxy.SNI']}"/>
                        </h:panelGroup>

                        <h:panelGroup rendered="#{currentChannel.isHttpRewrite()}">
                            <span class="label label-info" style="font-size: smaller; font-style: italic;">
                                #{messages['net.ihe.gazelle.proxy.HTTPRewrite']}
                            </span>
                        </h:panelGroup>

                    </g:column>
                    <g:column sortBy="#{'proxyPort'}"
                              sortOrder="#{dataTableStateHolder.sortOrders['proxyPort']}"
                              filterBy="#{'proxyPort'}">
                        <ui:define name="header">
                            <h:outputText
                                    value="#{messages['net.ihe.gazelle.proxy.ProxyPort_2']}"/>
                        </ui:define>
                        <h:outputText value="#{currentChannel.proxyPort}"/>
                    </g:column>
                    <g:column sortBy="#{'responder.hostname'}"
                              sortOrder="#{dataTableStateHolder.sortOrders['responder.hostname']}"
                              filterBy="#{'responder.hostname'}">
                        <ui:define name="header">
                            <h:outputText
                                    value="#{messages['net.ihe.gazelle.proxy.ProxyConsumerHost']}"/>
                        </ui:define>
                        <h:outputText
                                value="#{currentChannel.responder.hostname}"/>
                    </g:column>
                    <g:column sortBy="#{'responder.port'}"
                              sortOrder="#{dataTableStateHolder.sortOrders['responder.port']}"
                              filterBy="#{'responder.port'}">
                        <ui:define name="header">
                            <h:outputText
                                    value="#{messages['net.ihe.gazelle.proxy.ProxyConsumerPort']}"/>
                        </ui:define>
                        <h:outputText
                                value="#{currentChannel.responder.port}"/>
                    </g:column>
                    <g:column>
                        <ui:define name="header">
                            <h:outputText
                                    value="#{messages['net.ihe.gazelle.proxy.ChannelAction']}"/>
                        </ui:define>

                        <a4j:commandButton value="#{messages['net.ihe.gazelle.proxy.Delete']}"
                                           actionListener="#{channelManagerBean.setChannelToStop(currentChannel.proxyPort)}"
                                           oncomplete="jq162('#stopPanel').modal('show');"
                                           styleClass="gzl-btn-red" render=":stopPanelForm"
                                           rendered="#{applicationConfigurationManager.isUserAllowedAsAdmin()}"/>

                        <h:commandButton
                                value="#{messages['net.ihe.gazelle.proxy.Details']}"
                                action="#{messagesBean.redirectToDatahouseMessages(currentChannel.type, currentChannel.proxyPort, currentChannel.responder.port, currentChannel.responder.ip)}"
                                styleClass="gzl-btn"/>
                        <h:commandButton action="#{channelManagerBean.unPersistChannel(currentChannel.proxyPort)}"
                                         value="#{messages['net.ihe.gazelle.proxy.MakeTemporary']}"
                                         rendered="#{currentChannel.persistent and applicationConfigurationManager.isUserAllowedAsAdmin()}"
                                         execute="@this" immediate="true" styleClass="gzl-btn-orange"/>

                    </g:column>
                    <f:facet name="footer">
                        <ui:include src="/util/datatableFooter.xhtml">
                            <ui:param name="dataScrollerId" value="datascroller"/>
                            <ui:param name="dataTableId" value="channelTable"/>
                        </ui:include>
                    </f:facet>
                </rich:dataTable>

            </s:div>
        </h:form>
        <h:form id="stopPanelForm">
            <s:token allowMultiplePosts="true"/>
            <ui:decorate template="/layout/popup/_popup_title_footer.xhtml">
                <ui:param name="popup_id" value="stopPanel"/>
                <ui:define name="popup_title">#{messages['net.ihe.gazelle.proxy.StopAndDeleteChannel']}</ui:define>
                <p>#{messages['net.ihe.gazelle.proxy.ThisChannelWillBeStoppedAndDeletedEvenIfPermanen']}</p>
                <ui:define name="popup_footer">
                    <button type="button" class="gzl-btn" data-dismiss="modal">
                        #{messages['net.ihe.gazelle.proxy.Cancel']}
                    </button>
                    <a4j:commandButton id="deleteObjectAttributebutton"
                                       value="#{messages['net.ihe.gazelle.proxy.DeleteChannel']}"
                                       styleClass="gzl-btn-red"
                                       actionListener="#{channelManagerBean.stopChannelReal()}"
                                       onclick="jq162('#stopPanel').modal('hide');"
                                       render="listOfChannelsForm"/>
                </ui:define>
            </ui:decorate>
        </h:form>

        <h:form id="stopAllPanelForm">
            <s:token allowMultiplePosts="true"/>
            <ui:decorate template="/layout/popup/_popup_title_footer.xhtml">
                <ui:param name="popup_id" value="stopAllPanel"/>
                <ui:define name="popup_title">#{messages['net.ihe.gazelle.proxy.StopAndDeleteAllChannels']}</ui:define>
                <p>#{messages['net.ihe.gazelle.proxy.AllChannelsincludingPermanentOnesWillBeStoppedAn']}</p>
                <ui:define name="popup_footer">
                    <button type="button" class="gzl-btn" data-dismiss="modal">
                        #{messages['net.ihe.gazelle.proxy.Cancel']}
                    </button>
                    <a4j:commandButton id="deleteObjectAttributebutton"
                                       value="#{messages['net.ihe.gazelle.proxy.StopAndDeleteAllChannels']}"
                                       styleClass="gzl-btn-red"
                                       actionListener="#{channelManagerBean.stopAndDeleteAllChannels()}"
                                       onclick="jq162('#stopAllPanel').modal('hide');"
                                       render="listOfChannelsForm"/>
                </ui:define>
            </ui:decorate>
        </h:form>

        <h:form id="stopUnPersistedPanelForm">
            <s:token allowMultiplePosts="true"/>
            <ui:decorate template="/layout/popup/_popup_title_footer.xhtml">
                <ui:param name="popup_id" value="stopUnPersistedPanel"/>
                <ui:define name="popup_title">#{messages['net.ihe.gazelle.proxy.DeleteTemporaryChannels']}</ui:define>
                <p>#{messages['net.ihe.gazelle.proxy.AllTemporaryChannelsWillBeStoppedAreYouSureYouWa']}</p>
                <ui:define name="popup_footer">
                    <button type="button" class="gzl-btn" data-dismiss="modal">
                        #{messages['net.ihe.gazelle.proxy.Cancel']}
                    </button>
                    <a4j:commandButton id="deleteObjectAttributebutton"
                                       value="#{messages['net.ihe.gazelle.proxy.StopAllTemporaryChannels']}"
                                       styleClass="gzl-btn-red"
                                       actionListener="#{channelManagerBean.stopAllUnPersistedChannels()}"
                                       onclick="jq162('#stopUnPersistedPanel').modal('hide');"
                                       render="listOfChannelsForm"/>
                </ui:define>
            </ui:decorate>
        </h:form>

    </ui:define>
</ui:composition>
